// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: capbankmodule/capbankmodule.proto

package openfmb.capbankmodule;

/**
 * <pre>
 * Point definition (Point)
 * </pre>
 *
 * Protobuf type {@code capbankmodule.CapBankPoint}
 */
public final class CapBankPoint extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:capbankmodule.CapBankPoint)
    CapBankPointOrBuilder {
private static final long serialVersionUID = 0L;
  // Use CapBankPoint.newBuilder() to construct.
  private CapBankPoint(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private CapBankPoint() {
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new CapBankPoint();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.capbankmodule.Capbankmodule.internal_static_capbankmodule_CapBankPoint_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.capbankmodule.Capbankmodule.internal_static_capbankmodule_CapBankPoint_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.capbankmodule.CapBankPoint.class, openfmb.capbankmodule.CapBankPoint.Builder.class);
  }

  public static final int CONTROL_FIELD_NUMBER = 1;
  private openfmb.capbankmodule.CapBankControlYPSH control_;
  /**
   * <pre>
   * Regulator control
   * </pre>
   *
   * <code>.capbankmodule.CapBankControlYPSH control = 1;</code>
   * @return Whether the control field is set.
   */
  @java.lang.Override
  public boolean hasControl() {
    return control_ != null;
  }
  /**
   * <pre>
   * Regulator control
   * </pre>
   *
   * <code>.capbankmodule.CapBankControlYPSH control = 1;</code>
   * @return The control.
   */
  @java.lang.Override
  public openfmb.capbankmodule.CapBankControlYPSH getControl() {
    return control_ == null ? openfmb.capbankmodule.CapBankControlYPSH.getDefaultInstance() : control_;
  }
  /**
   * <pre>
   * Regulator control
   * </pre>
   *
   * <code>.capbankmodule.CapBankControlYPSH control = 1;</code>
   */
  @java.lang.Override
  public openfmb.capbankmodule.CapBankControlYPSHOrBuilder getControlOrBuilder() {
    return control_ == null ? openfmb.capbankmodule.CapBankControlYPSH.getDefaultInstance() : control_;
  }

  public static final int STARTTIME_FIELD_NUMBER = 2;
  private openfmb.commonmodule.Timestamp startTime_;
  /**
   * <pre>
   * Start time
   * </pre>
   *
   * <code>.commonmodule.Timestamp startTime = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return Whether the startTime field is set.
   */
  @java.lang.Override
  public boolean hasStartTime() {
    return startTime_ != null;
  }
  /**
   * <pre>
   * Start time
   * </pre>
   *
   * <code>.commonmodule.Timestamp startTime = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The startTime.
   */
  @java.lang.Override
  public openfmb.commonmodule.Timestamp getStartTime() {
    return startTime_ == null ? openfmb.commonmodule.Timestamp.getDefaultInstance() : startTime_;
  }
  /**
   * <pre>
   * Start time
   * </pre>
   *
   * <code>.commonmodule.Timestamp startTime = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.TimestampOrBuilder getStartTimeOrBuilder() {
    return startTime_ == null ? openfmb.commonmodule.Timestamp.getDefaultInstance() : startTime_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (control_ != null) {
      output.writeMessage(1, getControl());
    }
    if (startTime_ != null) {
      output.writeMessage(2, getStartTime());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (control_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getControl());
    }
    if (startTime_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, getStartTime());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.capbankmodule.CapBankPoint)) {
      return super.equals(obj);
    }
    openfmb.capbankmodule.CapBankPoint other = (openfmb.capbankmodule.CapBankPoint) obj;

    if (hasControl() != other.hasControl()) return false;
    if (hasControl()) {
      if (!getControl()
          .equals(other.getControl())) return false;
    }
    if (hasStartTime() != other.hasStartTime()) return false;
    if (hasStartTime()) {
      if (!getStartTime()
          .equals(other.getStartTime())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasControl()) {
      hash = (37 * hash) + CONTROL_FIELD_NUMBER;
      hash = (53 * hash) + getControl().hashCode();
    }
    if (hasStartTime()) {
      hash = (37 * hash) + STARTTIME_FIELD_NUMBER;
      hash = (53 * hash) + getStartTime().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.capbankmodule.CapBankPoint parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.capbankmodule.CapBankPoint parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.capbankmodule.CapBankPoint parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.capbankmodule.CapBankPoint parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.capbankmodule.CapBankPoint parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.capbankmodule.CapBankPoint parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.capbankmodule.CapBankPoint parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.capbankmodule.CapBankPoint parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.capbankmodule.CapBankPoint parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.capbankmodule.CapBankPoint parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.capbankmodule.CapBankPoint parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.capbankmodule.CapBankPoint parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.capbankmodule.CapBankPoint prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * Point definition (Point)
   * </pre>
   *
   * Protobuf type {@code capbankmodule.CapBankPoint}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:capbankmodule.CapBankPoint)
      openfmb.capbankmodule.CapBankPointOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.capbankmodule.Capbankmodule.internal_static_capbankmodule_CapBankPoint_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.capbankmodule.Capbankmodule.internal_static_capbankmodule_CapBankPoint_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.capbankmodule.CapBankPoint.class, openfmb.capbankmodule.CapBankPoint.Builder.class);
    }

    // Construct using openfmb.capbankmodule.CapBankPoint.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      control_ = null;
      if (controlBuilder_ != null) {
        controlBuilder_.dispose();
        controlBuilder_ = null;
      }
      startTime_ = null;
      if (startTimeBuilder_ != null) {
        startTimeBuilder_.dispose();
        startTimeBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.capbankmodule.Capbankmodule.internal_static_capbankmodule_CapBankPoint_descriptor;
    }

    @java.lang.Override
    public openfmb.capbankmodule.CapBankPoint getDefaultInstanceForType() {
      return openfmb.capbankmodule.CapBankPoint.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.capbankmodule.CapBankPoint build() {
      openfmb.capbankmodule.CapBankPoint result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.capbankmodule.CapBankPoint buildPartial() {
      openfmb.capbankmodule.CapBankPoint result = new openfmb.capbankmodule.CapBankPoint(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.capbankmodule.CapBankPoint result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.control_ = controlBuilder_ == null
            ? control_
            : controlBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.startTime_ = startTimeBuilder_ == null
            ? startTime_
            : startTimeBuilder_.build();
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.capbankmodule.CapBankPoint) {
        return mergeFrom((openfmb.capbankmodule.CapBankPoint)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.capbankmodule.CapBankPoint other) {
      if (other == openfmb.capbankmodule.CapBankPoint.getDefaultInstance()) return this;
      if (other.hasControl()) {
        mergeControl(other.getControl());
      }
      if (other.hasStartTime()) {
        mergeStartTime(other.getStartTime());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              input.readMessage(
                  getControlFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000001;
              break;
            } // case 10
            case 18: {
              input.readMessage(
                  getStartTimeFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000002;
              break;
            } // case 18
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private openfmb.capbankmodule.CapBankControlYPSH control_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.capbankmodule.CapBankControlYPSH, openfmb.capbankmodule.CapBankControlYPSH.Builder, openfmb.capbankmodule.CapBankControlYPSHOrBuilder> controlBuilder_;
    /**
     * <pre>
     * Regulator control
     * </pre>
     *
     * <code>.capbankmodule.CapBankControlYPSH control = 1;</code>
     * @return Whether the control field is set.
     */
    public boolean hasControl() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <pre>
     * Regulator control
     * </pre>
     *
     * <code>.capbankmodule.CapBankControlYPSH control = 1;</code>
     * @return The control.
     */
    public openfmb.capbankmodule.CapBankControlYPSH getControl() {
      if (controlBuilder_ == null) {
        return control_ == null ? openfmb.capbankmodule.CapBankControlYPSH.getDefaultInstance() : control_;
      } else {
        return controlBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Regulator control
     * </pre>
     *
     * <code>.capbankmodule.CapBankControlYPSH control = 1;</code>
     */
    public Builder setControl(openfmb.capbankmodule.CapBankControlYPSH value) {
      if (controlBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        control_ = value;
      } else {
        controlBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Regulator control
     * </pre>
     *
     * <code>.capbankmodule.CapBankControlYPSH control = 1;</code>
     */
    public Builder setControl(
        openfmb.capbankmodule.CapBankControlYPSH.Builder builderForValue) {
      if (controlBuilder_ == null) {
        control_ = builderForValue.build();
      } else {
        controlBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Regulator control
     * </pre>
     *
     * <code>.capbankmodule.CapBankControlYPSH control = 1;</code>
     */
    public Builder mergeControl(openfmb.capbankmodule.CapBankControlYPSH value) {
      if (controlBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0) &&
          control_ != null &&
          control_ != openfmb.capbankmodule.CapBankControlYPSH.getDefaultInstance()) {
          getControlBuilder().mergeFrom(value);
        } else {
          control_ = value;
        }
      } else {
        controlBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Regulator control
     * </pre>
     *
     * <code>.capbankmodule.CapBankControlYPSH control = 1;</code>
     */
    public Builder clearControl() {
      bitField0_ = (bitField0_ & ~0x00000001);
      control_ = null;
      if (controlBuilder_ != null) {
        controlBuilder_.dispose();
        controlBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Regulator control
     * </pre>
     *
     * <code>.capbankmodule.CapBankControlYPSH control = 1;</code>
     */
    public openfmb.capbankmodule.CapBankControlYPSH.Builder getControlBuilder() {
      bitField0_ |= 0x00000001;
      onChanged();
      return getControlFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Regulator control
     * </pre>
     *
     * <code>.capbankmodule.CapBankControlYPSH control = 1;</code>
     */
    public openfmb.capbankmodule.CapBankControlYPSHOrBuilder getControlOrBuilder() {
      if (controlBuilder_ != null) {
        return controlBuilder_.getMessageOrBuilder();
      } else {
        return control_ == null ?
            openfmb.capbankmodule.CapBankControlYPSH.getDefaultInstance() : control_;
      }
    }
    /**
     * <pre>
     * Regulator control
     * </pre>
     *
     * <code>.capbankmodule.CapBankControlYPSH control = 1;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.capbankmodule.CapBankControlYPSH, openfmb.capbankmodule.CapBankControlYPSH.Builder, openfmb.capbankmodule.CapBankControlYPSHOrBuilder> 
        getControlFieldBuilder() {
      if (controlBuilder_ == null) {
        controlBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.capbankmodule.CapBankControlYPSH, openfmb.capbankmodule.CapBankControlYPSH.Builder, openfmb.capbankmodule.CapBankControlYPSHOrBuilder>(
                getControl(),
                getParentForChildren(),
                isClean());
        control_ = null;
      }
      return controlBuilder_;
    }

    private openfmb.commonmodule.Timestamp startTime_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.Timestamp, openfmb.commonmodule.Timestamp.Builder, openfmb.commonmodule.TimestampOrBuilder> startTimeBuilder_;
    /**
     * <pre>
     * Start time
     * </pre>
     *
     * <code>.commonmodule.Timestamp startTime = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return Whether the startTime field is set.
     */
    public boolean hasStartTime() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <pre>
     * Start time
     * </pre>
     *
     * <code>.commonmodule.Timestamp startTime = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The startTime.
     */
    public openfmb.commonmodule.Timestamp getStartTime() {
      if (startTimeBuilder_ == null) {
        return startTime_ == null ? openfmb.commonmodule.Timestamp.getDefaultInstance() : startTime_;
      } else {
        return startTimeBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Start time
     * </pre>
     *
     * <code>.commonmodule.Timestamp startTime = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setStartTime(openfmb.commonmodule.Timestamp value) {
      if (startTimeBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        startTime_ = value;
      } else {
        startTimeBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Start time
     * </pre>
     *
     * <code>.commonmodule.Timestamp startTime = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setStartTime(
        openfmb.commonmodule.Timestamp.Builder builderForValue) {
      if (startTimeBuilder_ == null) {
        startTime_ = builderForValue.build();
      } else {
        startTimeBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Start time
     * </pre>
     *
     * <code>.commonmodule.Timestamp startTime = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder mergeStartTime(openfmb.commonmodule.Timestamp value) {
      if (startTimeBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0) &&
          startTime_ != null &&
          startTime_ != openfmb.commonmodule.Timestamp.getDefaultInstance()) {
          getStartTimeBuilder().mergeFrom(value);
        } else {
          startTime_ = value;
        }
      } else {
        startTimeBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Start time
     * </pre>
     *
     * <code>.commonmodule.Timestamp startTime = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder clearStartTime() {
      bitField0_ = (bitField0_ & ~0x00000002);
      startTime_ = null;
      if (startTimeBuilder_ != null) {
        startTimeBuilder_.dispose();
        startTimeBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Start time
     * </pre>
     *
     * <code>.commonmodule.Timestamp startTime = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.commonmodule.Timestamp.Builder getStartTimeBuilder() {
      bitField0_ |= 0x00000002;
      onChanged();
      return getStartTimeFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Start time
     * </pre>
     *
     * <code>.commonmodule.Timestamp startTime = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.commonmodule.TimestampOrBuilder getStartTimeOrBuilder() {
      if (startTimeBuilder_ != null) {
        return startTimeBuilder_.getMessageOrBuilder();
      } else {
        return startTime_ == null ?
            openfmb.commonmodule.Timestamp.getDefaultInstance() : startTime_;
      }
    }
    /**
     * <pre>
     * Start time
     * </pre>
     *
     * <code>.commonmodule.Timestamp startTime = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.Timestamp, openfmb.commonmodule.Timestamp.Builder, openfmb.commonmodule.TimestampOrBuilder> 
        getStartTimeFieldBuilder() {
      if (startTimeBuilder_ == null) {
        startTimeBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.Timestamp, openfmb.commonmodule.Timestamp.Builder, openfmb.commonmodule.TimestampOrBuilder>(
                getStartTime(),
                getParentForChildren(),
                isClean());
        startTime_ = null;
      }
      return startTimeBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:capbankmodule.CapBankPoint)
  }

  // @@protoc_insertion_point(class_scope:capbankmodule.CapBankPoint)
  private static final openfmb.capbankmodule.CapBankPoint DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.capbankmodule.CapBankPoint();
  }

  public static openfmb.capbankmodule.CapBankPoint getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<CapBankPoint>
      PARSER = new com.google.protobuf.AbstractParser<CapBankPoint>() {
    @java.lang.Override
    public CapBankPoint parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<CapBankPoint> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<CapBankPoint> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.capbankmodule.CapBankPoint getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

